/***************************************************************************
                            -  description
                             -------------------
    begin                : Wed Mar 22 2000
    copyright            : (C) 2000 by Siegfried Nijssen
    email                : snijssen@cs.leidenuniv.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "facttable.h"
#include "type.h"

void FactTable::initTable ( FactTableCell &cells, int dimensions, int *sizes ) {
  int size;

  if ( dimensions > 1 ) {
    cells.celldata = new FactTableCell[sizes[0]];
    for ( int i = 0; i < sizes[0]; i++ )
      initTable ( cells.celldata[i], dimensions - 1, sizes + 1 );
  }
  else {
    size = ( sizes[0] + 31 ) / 32;
    cells.celldata = new FactTableCell[size];
    for ( int i = 0; i < size; i++ )
      cells.celldata[i].bitdata = 0;
  }
}

void FactTable::removeTable ( FactTableCell cells, int dimensions, int *sizes ) {
  if ( dimensions > 1 )
    for ( int i = 0; i < sizes[0]; i++ )
      removeTable ( cells.celldata[i], dimensions, sizes + 1 );
  delete[] cells.celldata;
}

FactTable::FactTable ( int dimensions, int *sizes ) {
  this->dimensions = dimensions;
  this->sizes = sizes;
  initTable ( cells, dimensions, sizes );
}

FactTable::~FactTable () {
  removeTable ( cells, dimensions, sizes );
}

void FactTable::setFact ( INTTYPE *coor, bool value ) {
  FactTableCell cell = cells;
  int i;
  for ( i = 0; i < dimensions - 1; i++ )
    cell = cell.celldata[coor[i]];
  int nr = coor[i] / 32, bnr = coor[i] % 32;
  cell.celldata[nr].bitdata = value ? ( cell.celldata[nr].bitdata | ( 1 << bnr ) ) : ( cell.celldata[nr].bitdata & ~ ( 1 << bnr ) );
}
