/***************************************************************************
                            -  description
                             -------------------
    begin                : Wed Mar 22 2000
    copyright            : (C) 2000 by Siegfried Nijssen
    email                : snijssen@cs.leidenuniv.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef FACTTABLE_H
#define FACTTABLE_H
#include "type.h"

union FactTableCell {
  unsigned int bitdata;
  FactTableCell *celldata;
};

class BaseFactTable {
  public:
    BaseFactTable () { ; }
    virtual ~BaseFactTable () { ; }
    virtual bool getFact ( INTTYPE *coor ) = 0;
};

class FactTable:public BaseFactTable {
  public:
    FactTable ( int dimensions, int *sizes );
    virtual ~FactTable ();
    void setFact ( INTTYPE *coor, bool value );
    bool getFact ( INTTYPE *coor ) {
      FactTableCell cell = cells;
      int i;
      for ( i = 0; i < dimensions - 1; i++ )
        cell = cell.celldata[coor[i]];
      return cell.celldata[coor[i]/32].bitdata & ( 1 << ( coor[i] % 32 ) );
    }
  private:
    void initTable ( FactTableCell &cells, int dimensions, int *sizes );
    void removeTable ( FactTableCell cells, int dimensions, int *sizes );
    FactTableCell cells;
    int dimensions;
    int *sizes;
};

typedef bool (*TgetFact) ( INTTYPE *coor );
TgetFact extern_lookup_facttable ( char *name );

class ExternalFactTable:public BaseFactTable {
  public:
    ExternalFactTable ( char *functionname ) {
      function = extern_lookup_facttable ( functionname );
    }
    bool getFact ( INTTYPE *coor ) {
      return function ( coor );
    }
  private:
    TgetFact function;  
};

#endif

