/***************************************************************************
                          predicatetable.h  -  description
                             -------------------
    begin                : Tue Mar 21 2000
    copyright            : (C) 2000 by Siegfried Nijssen
    email                : snijssen@cs.leidenuniv.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PREDICATETABLE_H
#define PREDICATETABLE_H
#include "nametable.h"
#include "modetable.h"
#include "type.h"

/**A table containing the names of predicates and their numbers
  *@author Siegfried Nijssen
  */

class BaseFactTable;

struct PredicateData {
  char *name;
  int nr;
  int size;
  int *params;
  ModeData **modes;
  int nmodes, filln; // fillin used by modetable.fillDependencies
  bool key;
  BaseFactTable *facttable;
};

void setFact ( PredicateData *pd, INTTYPE *coors );

class PredicateTable {
  public:
  	PredicateTable();
  	~PredicateTable();
      /** add a predicate to the table */
    void addPredicate ( char *predicate_name, int size, int *params );
    PredicateData *getPredicate ( char *predicate_name );
    PredicateData *getPredicate ( int nr ) { return array[nr]; }
    void print ();
    void fillArray ();
    int size;
    PredicateData **array;
  private:
    NameTable predicatenames;	
    struct PredicateDataLE {
      PredicateData *data;
      PredicateDataLE *next;
    } *list;
    bool filledarray;
};

#endif
