/***************************************************************************
                          main.cpp  - main for console
                                      interface farmer
                             -------------------
    begin                : Tue Mar 21 2000
    copyright            : (C) 2000 by Siegfried Nijssen
    email                : snijssen@cs.leidenuniv.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "parser.h"
#include "interpreter.h"
#include "globaldata.h"
#include "modefacttable.h" // to be removed
#include "tree.h"
#include "extern.h"
#include <iostream.h>
#include <sys/time.h>

void header () {
  cerr << "************ " << endl
       << "** Farmer ** " << endl
       << "************ " << endl
       << "Discovery of frequent queries" << endl
       << "Siegfried Nijssen 2000" << endl;
}

main ( int argc, char *argv[] ) {
  char *filename;
  timeval tv1, tv2;
  int rc = 0;

  header ();
  if ( argc != 2 ) {
    cerr << "No input file!" << endl;
    return -1;
  }
  filename = argv[1];
  parse ( filename, interpret, 'f' );
  cerr << "[Finished reading input]" << endl;
  assertfilledbias ();
  cerr << "[Extern initialization]" << endl;
  extern_init ();
  //typetable.print ();
  //predicatetable.print ();
  //modetable.print ();
  globaldata_print ();
  initTree ();
  cerr << "[Starting search]" << endl;
  bool cont = true;
  gettimeofday ( &tv1, NULL );

  do {
    cerr << "[Counting " << rc << "]" << endl;
    countTree ();
    //cerr << "[Printing " << rc << "]" << endl;
    //printTree ( false );
    cerr << "[Expanding " << rc << "]" << endl;
    rc++;
  }
  while ( expandTree () && ( maxloop == -1 || rc <= maxloop ) );
  cerr << "[Determine interesting]" << endl;
  determineInteresting ();
  cerr << "[Printing interesting]" << endl;
  printInterestingQueries ();

  gettimeofday ( &tv2, NULL );
  cerr << "[Finished in " << ( tv2.tv_sec - tv1.tv_sec )* 1000 + ( tv2.tv_usec - tv1.tv_usec ) / 1000  << "ms]" << endl;
}




