/***************************************************************************
                         nodetoqstring.cpp  -  Visual Farmer
                             -------------------
    begin                : Wed Jul 19 2000
    copyright            : (C) 2000 by Siegfried Nijssen
    email                : snijssen@cs.leidenuniv.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "nodetoqstring.h"
#include "farmer/globaldata.h"

QString &operator+= ( QString &textin, Node *node ) {
  ModeData *md = modetable.array + MODE ( node );
  PredicateData *pd = predicatetable.array[md->predicate];
  textin = textin + pd->name + "(";
  for ( int i = 0; i < md->size; i++ ) {
    switch ( md->params[i].type ) {
      case Plus: textin = textin + "+" + QString ().setNum ( pd->params[i] ) + "." + QString ().setNum ( node->params[i] ); break;
      case Min: textin = textin + "-" + QString ().setNum ( pd->params[i] ) + "." + QString ().setNum ( node->params[i] ); break;
      case MinEx: textin = textin + "\\" + QString ().setNum ( pd->params[i] ) + "." + QString ().setNum ( node->params[i] ); break;
      case Constant:
        if ( showconstantnames )
          textin = textin + typetable.getConstantName ( pd->params[i], node->params[i] );
        else
          textin = textin + "#" + QString ().setNum ( pd->params[i] ) + "." + QString ().setNum ( node->params[i] );
        break;
    }

    if ( i < md->size - 1 )
      textin = textin + ", ";
  }
  textin = textin + ")";
  return textin;
}

QString &toQString ( int n, Node **nodes ) {
  static QString text;
  int i;
  text = "";
  for ( i = 0; i < n - 1; i++ ) {
    text += nodes[i];
    text += ", ";
  }
  text += nodes[i];
  return text;
}

QString &toQString ( int n, Node **nodes, bool *added ) {
  static QString text;
  bool first = true;
  int i;
  text = "";
  for ( i = 0; i < n; i++ ) {
    if ( added[i] ) {
      if ( !first )
        text += ", ";
      text += nodes[i];
      first = false;
    }
  }
  return text;
}
