/***************************************************************************
                        qgraphatom.h  -  Visual farmer
                             -------------------
    begin                : Wed Jul 19 2000
    copyright            : (C) 2000 by Siegfried Nijssen
    email                : snijssen@cs.leidenuniv.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QGRAPHATOM_H
#define QGRAPHATOM_H

#include <qwidget.h>
#include "farmer/tree.h"

/**This class can be used to display an atom.
  *@author Siegfried Nijssen
  */

class QGraphAtom : public QWidget  {
   Q_OBJECT
public: 
	QGraphAtom(int n, Node **nodes, QWidget *parent=0, const char *name=0);
	~QGraphAtom();
	int accessX ( int j ) { return ( x[j + 1] + x[j + 2] ) / 2; }
	void setHighlight ( bool val );
protected:
	void paintEvent ( QPaintEvent * );
	void mouseMoveEvent ( QMouseEvent * );
	void mousePressEvent ( QMouseEvent * );
	void mouseReleaseEvent ( QMouseEvent * );
private:
	void fillCoors ();
	int n;
	Node **nodes;
	int *x;
	int w, h;
	int dragx, dragy, tx, ty;
	bool highlight;
};

#endif
