/***************************************************************************
                        qgraphquery.h  -  Visual farmer
                             -------------------
    begin                : Wed Jul 19 2000
    copyright            : (C) 2000 by Siegfried Nijssen
    email                : snijssen@cs.leidenuniv.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QGRAPHQUERY_H
#define QGRAPHQUERY_H

#include <qwidget.h>
#include <qscrollview.h>
#include "farmer/tree.h"
#include "qgraphatom.h"
#include "qlist.h"

/**This class can be used to show a graphical representation of a query
  *@author Siegfried Nijssen
  */

class QGraphQuery : public QScrollView  {
   Q_OBJECT
public: 
  QGraphQuery(QWidget *parent=0, const char *name=0);
  ~QGraphQuery();
 /** Set the query which is shown by the view */
  void setQuery ( int n, Node **nodes );
  void setHighlight ( int n, bool *highlighted );
protected:
  void drawContentsOffset ( QPainter * p, int offsetx, int offsety, int clipx, int clipy, int clipw, int cliph );
private:
  Node **nodes;
  int n;
  QList<QGraphAtom> qatoms;
  struct QGraphAtomArrow {
    QGraphAtom *beginatom, *endatom;
    int beginx, endx;
  };
  QList<QGraphAtomArrow> qlines;
  void addNode ( int i, Node **nodes, int *atomdepth, int *atomstartx );
  int searchForAtom ( int k, int typenr, int varnr, QGraphAtomArrow *graphatomarrow, int *atomdepth );
};

#endif
