/***************************************************************************
                         visualfarmerdoc.cpp  -  Visual Farmer
                             -------------------
    begin                : Mon Jul 10 20:04:47 CEST 2000
    copyright            : (C) 2000 by Siegfried Nijssen
    email                : snijssen@cs.leidenuniv.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "visualfarmerdoc.h"
#include "farmer/parser.h"
#include "farmer/interpreter.h"
#include "farmer/extern.h"
#include "farmer/tree.h"
#include "farmer/output.h"
#include "farmer/globaldata.h"

VisualfarmerDoc::VisualfarmerDoc()
{
  modified = false;
}

VisualfarmerDoc::~VisualfarmerDoc()
{
}

void VisualfarmerDoc::newDoc()
{
}

bool VisualfarmerDoc::save()
{
  return true;
}

bool VisualfarmerDoc::saveAs(const QString &filename)
{
  return true;
}

bool VisualfarmerDoc::load(const QString &filename)
{
  QMonitorDialog *monitor = new QMonitorDialog;
  monitor->show ();
  bool result;
  showconstantnames = true;

  result = parse ( filename, interpret, 'f' );

  ERR << "[Finished reading input]";
  ERR_F

  if ( !result ) {
    ERR << "-- There were errors, bailing out --" << endl;
    ERR_F
  }
  else {
    int rc = 1;
    assertfilledbias ();
    ERR << "[Extern initialization]";
    ERR_F
    extern_init ();
    globaldata_print ();
    initTree ();
    ERR << "[Starting search]";
    ERR_F
    do {
      ERR << "[Counting " << rc << "]";
      ERR_F
      countTree ();
      ERR << "[Expanding " << rc << "]";
      ERR_F
      rc++;
    }
    while ( expandTree () && ( maxloop == -1 || rc <= maxloop ) );

    ERR << "[Determining interesting]";
    ERR_F
    determineInteresting ();
    emit documentChanged();
  }

  monitor->exec ();

  return true;
}

bool VisualfarmerDoc::isModified() const
{
  return modified;
}
