/***************************************************************************
                        visualfarmerview.h  -  Visual farmer
                             -------------------
    begin                : Mon Jul 10 20:04:47 CEST 2000
    copyright            : (C) 2000 by Siegfried Nijssen
    email                : snijssen@cs.leidenuniv.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef VISUALFARMERVIEW_H
#define VISUALFARMERVIEW_H

// include files for QT
#include <qwidget.h>
#include <qsplitter.h>
#include <qlistview.h>

// application specific includes
#include "visualfarmerdoc.h"
#include <nodetoqstring.h>
#include "qgraphquery.h"

/**
 * This class provides an incomplete base for your application view. 
 */

class VisualfarmerView : public QSplitter
{
  Q_OBJECT
  public:
    VisualfarmerView(QWidget *parent=0, VisualfarmerDoc* doc=0);
    ~VisualfarmerView();
  
  protected slots:
    void slotDocumentChanged();
    void slotSelectionChanged ( QListViewItem *qlvi );
  private:
    void listMaximalQueries ();
    void listMaximalQueries ( Node *node, int depth );
    Node **nodehistory;
    QListView *listview;
    QGraphQuery *graphquery;

    class queryListViewItem:public QListViewItem {
      public:
        queryListViewItem ( QListView *lv, int n, Node **query );
        const char *text ( int column ) const;
        const char *key ( int column, bool ascending ) const;
        virtual ~queryListViewItem ();
        void setup ();
        void setOpen ( bool o );
        Node **query;
        int n;
    };
    class subsetListViewItem:public QListViewItem {
      public:
        subsetListViewItem ( queryListViewItem *qlvi, int n, bool *added, int support );
        const char *text ( int column ) const;
        const char *key ( int column, bool ascending ) const;
        virtual ~subsetListViewItem ();
        bool *added;
        int n;
        int support;
    };
};

#endif
